package com.yaohun.farmingwar;

import com.sk89q.worldedit.LocalSession;
import com.sk89q.worldedit.bukkit.BukkitAdapter;
import com.sk89q.worldedit.extension.platform.Actor;
import com.sk89q.worldedit.math.BlockVector3;
import com.yaohun.farmingwar.data.GameEditGui;
import com.yaohun.farmingwar.data.RepairGiftGui;
import com.yaohun.farmingwar.game.Game;
import com.yaohun.farmingwar.game.Point;
import com.yaohun.farmingwar.game.Region;
import com.yaohun.farmingwar.listener.*;
import com.yaohun.farmingwar.liveevent.GiftEventHandler;
import com.yaohun.farmingwar.liveevent.GiftListener;
import com.yaohun.farmingwar.liveevent.LikeListener;
import com.yaohun.farmingwar.manager.GameManager;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;
import tools.GameUtil;
import tools.RandomUtil;

import java.util.ArrayList;
import java.util.List;

public class FarmingWar extends JavaPlugin {

    private static FarmingWar instance;
    private static Game game;
    private static GameManager gameManager;

    @Override
    public void onEnable() {
        instance = this;
        gameManager = new GameManager();
        game = new Game(gameManager);
        Bukkit.getPluginManager().registerEvents(new GameEditGui(game), this);
        Bukkit.getPluginManager().registerEvents(new RepairGiftGui(), this);
        Bukkit.getPluginManager().registerEvents(new GiftListener(), this);
        Bukkit.getPluginManager().registerEvents(new LikeListener(gameManager), this);
        Bukkit.getPluginManager().registerEvents(new GamePotect(), this);
        Bukkit.getPluginManager().registerEvents(new GameEffectListener(), this);
        Bukkit.getPluginManager().registerEvents(new GameListener(this), this);
        Bukkit.getPluginManager().registerEvents(new PlayerListener(this), this);
        Bukkit.getPluginManager().registerEvents(new JoinListener(this), this);
        Bukkit.getPluginManager().registerEvents(new KeepEntitiesOnDeath(), this);
    }

    @Override
    public void onDisable() {
        gameManager.saveGameSettings();
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (label.equalsIgnoreCase("livegift")) {
            RepairGiftGui.OpenGui((Player) sender);
            return true;
        }
        if (label.equalsIgnoreCase("gameedit")) {
            GameEditGui.OpenGui((Player) sender);
            return true;
        }
        if (label.equalsIgnoreCase("game")) {
            if (args.length == 0) {
                sender.sendMessage("/game start - 开始游戏");
                return true;
            } else {
                String subCommand = args[0];
                if (subCommand.equalsIgnoreCase("start")) {
                    if (!(sender instanceof Player)) {
                        sender.sendMessage("非玩家无法开始游戏");
                        return true;
                    }
                    if (game.isStarted()) {
                        sender.sendMessage("游戏已开始");
                        return true;
                    }
                    game.start();
                } else if (subCommand.equalsIgnoreCase("region")) {
                    String regionKey = args[1];
                    Player player = (Player) sender;
                    Actor actor = BukkitAdapter.adapt(player);
                    LocalSession localSession = actor.getSession();
                    com.sk89q.worldedit.regions.Region region = localSession.getSelection(BukkitAdapter.adapt(player.getWorld()));
                    if (region == null) {
                        player.sendMessage("请先选中一个区域");
                        return true;
                    }
                    BlockVector3 min = region.getMinimumPoint();
                    BlockVector3 max = region.getMaximumPoint();
                    Point minPoint = new Point(min.getBlockX(), min.getBlockY(), min.getBlockZ());
                    Point maxPoint = new Point(max.getBlockX(), max.getBlockY(), max.getBlockZ());
                    Region region1 = new Region(player.getWorld(), minPoint, maxPoint);
                    game.createRegion(regionKey, region1);
                    player.sendMessage("区域创建成功.");
                } else if (args.length == 2 && args[0].equalsIgnoreCase("effect")) {
                    List<Player> players = new ArrayList<>(Bukkit.getOnlinePlayers());
                    Player player = players.get(0);
                    if (sender instanceof Player) {
                        player = (Player) sender;
                    }
                    String eventName = args[1];
                    String userName = "观众" + RandomUtil.getRandomInt(0, 10);
                    String title = "§c" + eventName;
                    String subtitle = "§9" + GameUtil.hideName(userName);
                    player.sendTitle(title, subtitle, 10, 30, 10);
                    GiftEventHandler.SendHandLer(player, userName, eventName);
                    return true;
                }
            }
        }
        return false;
    }

    public static Game getGame() {return game;}
    public static FarmingWar inst() {return instance;}
    public static GameManager getGameManager() {return gameManager;}
}
