package com.yaohun.farmingwar.data;

import com.yaohun.farmingwar.FarmingWar;
import com.yaohun.farmingwar.game.Game;
import com.yaohun.farmingwar.manager.GameManager;
import com.yaohun.farmingwar.util.BackPointType;
import de.tr7zw.nbtapi.NBTItem;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.World;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemFlag;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import tools.BossBarUtil;
import tools.CDTimeAPI;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class GameEditGui implements Listener {

    public static String invTitle = "我的世界整蛊 - 游戏设置管理";
    private Game game;
    public GameEditGui(Game gameMain){
        game = gameMain;
    }

    @EventHandler
    public void onClick(InventoryClickEvent e){
        int rawSlot = e.getRawSlot();
        Player zhubo = (Player) e.getWhoClicked();
        ItemStack item = e.getCurrentItem();
        if(e.getView().getTitle().equalsIgnoreCase(invTitle)){
            e.setCancelled(true);
            if(item == null || item.getType() == Material.AIR){
                return;
            }
            GameManager gameManager = FarmingWar.getGameManager();
            if(rawSlot == 0){
                zhubo.closeInventory();
                if(e.getClick() == ClickType.LEFT){
                    game.addBossBar(zhubo,game.getBossBar1());
                }else if(e.getClick() == ClickType.RIGHT){
                    game.removeBossBar(zhubo,game.getBossBar1());
                }
                zhubo.playSound(zhubo.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP,1,1);
                GameEditGui.OpenGui(zhubo);
            }
            if(rawSlot == 2){
                zhubo.closeInventory();
                if(e.getClick() == ClickType.LEFT){
                    game.addBossBar(zhubo,game.getBossBar2());
                }else if(e.getClick() == ClickType.RIGHT){
                    game.removeBossBar(zhubo,game.getBossBar2());
                }
                zhubo.playSound(zhubo.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP,1,1);
                GameEditGui.OpenGui(zhubo);
            }
            if(rawSlot == 4){
                if(e.getClick() == ClickType.LEFT){
                    long nowTime = gameManager.getGameTime()+500;
                    if(nowTime >= 18000){
                        nowTime = 18000;
                    }
                    gameManager.setGameTime(nowTime);
                } else if(e.getClick() == ClickType.RIGHT){
                    long nowTime = gameManager.getGameTime()-500;
                    if(nowTime <= 1000){
                        nowTime = 1000;
                    }
                    gameManager.setGameTime(nowTime);
                }
                zhubo.getWorld().setTime(gameManager.getGameTime());
                zhubo.playSound(zhubo.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP,1,1);
                GameEditGui.OpenGui(zhubo);
            }
            if(rawSlot == 8){
                zhubo.closeInventory();
                int amount = 0;
                for (CDTimeAPI.CDData data : CDTimeAPI.getCdData()) {
                    for (String key : data.getCdTime().keySet()){
                        data.setCD(key,-1L);
                        amount++;
                    }
                }
                Bukkit.broadcastMessage("§c[系统]§a本次总计清理负面效果: §e"+amount+"种");
                zhubo.playSound(zhubo.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP,1,1);
            }
            if(rawSlot == 9){
                if(gameManager.getBackPointType() == BackPointType.初始){
                    gameManager.setBackPointType(BackPointType.中间);
                }else if(gameManager.getBackPointType() == BackPointType.中间){
                    gameManager.setBackPointType(BackPointType.尽头);
                }else if(gameManager.getBackPointType() == BackPointType.尽头){
                    gameManager.setBackPointType(BackPointType.初始);
                }
                Bukkit.broadcastMessage("§c[系统]§a当前传送返回点为: §e"+gameManager.getBackPointType().name());
                zhubo.playSound(zhubo.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP,1,1);
                GameEditGui.OpenGui(zhubo);
            }
            if(rawSlot == 11){
                if(e.getClick() == ClickType.LEFT){
                    int nowTime = gameManager.getGoalCountdown()+1;
                    if(nowTime >= 20){
                        nowTime = 20;
                    }
                    gameManager.setGoalCountdown(nowTime);
                } else if(e.getClick() == ClickType.RIGHT){
                    int nowTime = gameManager.getGoalCountdown()-1;
                    if(nowTime <= 5){
                        nowTime = 5;
                    }
                    gameManager.setGoalCountdown(nowTime);
                }
                zhubo.playSound(zhubo.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP,1,1);
                GameEditGui.OpenGui(zhubo);
            }
            if(rawSlot == 13){
                zhubo.closeInventory();
                zhubo.getInventory().clear();// 清理背包物品
                game.initPlayerBackpack(zhubo);
                zhubo.playSound(zhubo.getLocation(), Sound.ITEM_ARMOR_EQUIP_DIAMOND,1,1);
            }
            if(rawSlot == 15){
                zhubo.closeInventory();
                World world = zhubo.getWorld();
                int amount = 0;
                for (Entity entity : world.getEntities()) {
                    if(!(entity instanceof Player)){
                        entity.remove();
                        amount++;
                    }
                }
                Bukkit.broadcastMessage("§c[系统]§a本次总计清理: §e"+amount+"个生物");
                zhubo.playSound(zhubo.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP,1,1);
            }
            if(rawSlot == 26){
                zhubo.closeInventory();
                if(e.getClick() == ClickType.LEFT){
                    // 重启游戏  重置矿区
                    FarmingWar.getGame().effect_setComplete(0); // 重置玩家当前已完成次数
                    game.reset();
                } else if(e.getClick() == ClickType.RIGHT){
                    // 关闭服务器
                    Bukkit.dispatchCommand(Bukkit.getConsoleSender(),"stop");
                }
                zhubo.playSound(zhubo.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP,1,1);
            }
            if(rawSlot >= 18 && rawSlot < 24){
                zhubo.closeInventory();
                NBTItem nbti = new NBTItem(item);
                int gameGoal = nbti.getInteger("gameGoal");
                FarmingWar.getGameManager().setGameGoal(gameGoal);
                Bukkit.broadcastMessage("§c[系统]§a今日挑战已设置为: §e"+gameGoal+"次");
                zhubo.playSound(zhubo.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP,1,1);
            }
        }
    }

    public static void OpenGui(Player p){
        Inventory inv = Bukkit.createInventory(null,27,invTitle);
        // 设置挑战次数
        inv.setItem(18,CompleteAmount(Material.WHITE_WOOL,5));
        inv.setItem(19,CompleteAmount(Material.LIGHT_GRAY_WOOL,10));
        inv.setItem(20,CompleteAmount(Material.PINK_WOOL,15));
        inv.setItem(21,CompleteAmount(Material.YELLOW_WOOL,20));
        inv.setItem(22,CompleteAmount(Material.LIGHT_BLUE_WOOL,30));
        inv.setItem(23,CompleteAmount(Material.RED_WOOL,50));

        inv.setItem(0,BossBar_1());
        inv.setItem(2,BossBar_2());
        inv.setItem(4,SetGameTime());
        inv.setItem(9,transferPointSetting());
        inv.setItem(11,SetCountdown());
        inv.setItem(13,equipThePlayer());
        inv.setItem(15,Scavenger());
        inv.setItem(8,Rest_Effect());
        inv.setItem(26,Rest_Server());
        p.openInventory(inv);
    }

        public static ItemStack CompleteAmount(Material material,int amount){
            ItemStack item = new ItemStack(material);
            item.setAmount(amount);
            ItemMeta meta = item.getItemMeta();
            meta.setDisplayName("§d★ §e挑战目标: §a"+amount+"次");
            List<String> lore = new ArrayList<>();
            lore.add("§8By.AuroraPixel");
            GameManager gameManager = FarmingWar.getGameManager();
            if(gameManager.getGameGoal() == amount) {
                lore.add("§b★ §c当前已经是目标"+amount+"次");
                item.addUnsafeEnchantment(Enchantment.ARROW_DAMAGE,1);
            } else {
                lore.add("§b★ §6左键点击 §7设置目标");
            }
            meta.setLore(lore);
            item.setItemMeta(meta);
            NBTItem nbti = new NBTItem(item);
            nbti.setInteger("gameGoal", amount);
            item = nbti.getItem();
            return item;
        }


    public static ItemStack transferPointSetting(){
        ItemStack item = new ItemStack(Material.SUGAR);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§d★ §eF键传送点");
        List<String> lore = new ArrayList<>();
        lore.add("§8By.AuroraPixel");
        GameManager gameManager = FarmingWar.getGameManager();
        lore.add("§b★ §7当前位置: §c"+gameManager.getBackPointType().name());
        lore.add(" ");
        lore.add("§b★ §6鼠标点击 §7切换位置");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        meta.setCustomModelData(203);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack equipThePlayer(){
        ItemStack item = new ItemStack(Material.SUGAR);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§d★ §e切换背包装备");
        List<String> lore = new ArrayList<>();
        lore.add("§8By.AuroraPixel");
        lore.add(" ");
        lore.add("§b★ §6鼠标点击切换装备");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        meta.setCustomModelData(206);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack Scavenger(){
        ItemStack item = new ItemStack(Material.SUGAR);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§d★ §e清理所有生物");
        List<String> lore = new ArrayList<>();
        lore.add("§8By.AuroraPixel");
        lore.add("§c清理猪猪,熊猫,僵尸等");
        lore.add(" ");
        lore.add("§b★ §6鼠标点击清理");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        meta.setCustomModelData(205);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack SetCountdown(){
        ItemStack item = new ItemStack(Material.SUGAR);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§d★ §e挑战完成倒计时");
        List<String> lore = new ArrayList<>();
        lore.add("§8By.AuroraPixel");
        GameManager gameManager = FarmingWar.getGameManager();
        lore.add("§b★ §7当前秒数: §c"+gameManager.getGoalCountdown()+"秒");
        lore.add(" ");
        lore.add("§b★ §6左键+1秒 §7|| §6右键-1秒");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        meta.setCustomModelData(204);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack Rest_Server(){
        ItemStack item = new ItemStack(Material.SUGAR);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§d★ §e重启游戏");
        List<String> lore = new ArrayList<>();
        lore.add("§8By.AuroraPixel");
        lore.add("§c重启后修改参数将生效");
        lore.add(" ");
        lore.add("§b★ §6左键 §7重置场地和数据");
        lore.add("§b★ §6右键 §7重置服务端");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        meta.setCustomModelData(202);
        item.setItemMeta(meta);
        return item;
    }
    public static ItemStack Rest_Effect(){
        ItemStack item = new ItemStack(Material.SUGAR);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§d★ §e清理负面效果");
        List<String> lore = new ArrayList<>();
        lore.add("§8By.AuroraPixel");
        lore.add("§c例如螺旋升天,关灯,大风车等");
        lore.add(" ");
        lore.add("§b★ §6鼠标点击清理");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        meta.setCustomModelData(208);
        item.setItemMeta(meta);
        return item;
    }


    public static ItemStack BossBar_1(){
        ItemStack item = new ItemStack(Material.SUGAR);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§d★ §e挑战进度血条");
        List<String> lore = new ArrayList<>();
        lore.add("§8By.AuroraPixel");
        lore.add(" ");
        lore.add("§b★ §6左键 §7显示");
        lore.add("§b★ §6右键 §7隐藏");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        meta.setCustomModelData(207);
        item.setItemMeta(meta);
        return item;
    }
    public static ItemStack BossBar_2(){
        ItemStack item = new ItemStack(Material.SUGAR);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§d★ §e小麦种植进度");
        List<String> lore = new ArrayList<>();
        lore.add("§8By.AuroraPixel");
        lore.add(" ");
        lore.add("§b★ §6左键 §7显示");
        lore.add("§b★ §6右键 §7隐藏");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        meta.setCustomModelData(207);
        item.setItemMeta(meta);
        return item;
    }


    public static ItemStack SetGameTime(){
        ItemStack item = new ItemStack(Material.SUGAR);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§d★ §e游戏时间锁定");
        List<String> lore = new ArrayList<>();
        lore.add("§8By.AuroraPixel");
        GameManager gameManager = FarmingWar.getGameManager();
        lore.add("§b★ §7当前秒数: §c"+gameManager.getGameTime()+"刻");
        lore.add(" ");
        lore.add("§b★ §6左键+500刻 §7|| §6右键-500刻");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        meta.setCustomModelData(209);
        item.setItemMeta(meta);
        return item;
    }
}
