package com.yaohun.farmingwar.effects;

import com.yaohun.farmingwar.FarmingWar;
import com.yaohun.farmingwar.game.Game;
import org.bukkit.Location;
import org.bukkit.Particle;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;
import tools.CDTimeAPI;

import java.util.UUID;

public class BigWindill {

    public static void apply(Game game, Player zhubo, int seconds){
        // 检测游戏是否启动
        if(!game.isStarted()){return;}
        // 获取主播的uuid
        UUID uuid = zhubo.getUniqueId();
        // 计时器key
        String timepieceKey = "bigWindill";
        startTimepieceEvent(game,zhubo,timepieceKey);
        if(CDTimeAPI.isCD(uuid,timepieceKey)){
            long newTime = CDTimeAPI.getCD(uuid,timepieceKey) + (995L * seconds);
            CDTimeAPI.setPlayerCD(uuid,timepieceKey,newTime);
        } else {
            CDTimeAPI.setPlayerCD(uuid,timepieceKey,995L * seconds);
        }
    }

    public static void startTimepieceEvent(Game game,Player zhubo,String timepieceKey){
        if(CDTimeAPI.isCD(zhubo.getUniqueId(),timepieceKey)){
            return;
        }
        zhubo.playSound(zhubo.getLocation(), "dafengche", 1, 1);
        BukkitTask task = new BukkitRunnable() {
            double yaw = 0;
            int time = 0;
            @Override
            public void run() {
                if (!CDTimeAPI.isCD(zhubo.getUniqueId(), timepieceKey)) {
                    cancel();
                    return;
                }
                if(time >= 55){
                    time -= 55;
                    zhubo.getWorld().strikeLightningEffect(zhubo.getLocation());
                    if(CDTimeAPI.getCD(zhubo.getUniqueId(),timepieceKey) >= 2000) {
                        zhubo.playSound(zhubo.getLocation(), "dafengche", 1, 1);
                    }
                }
                yaw += 45.0; // 每次旋转2度
                if (yaw >= 360) {
                    yaw -= 360;
                }
                // 获取玩家当前位置
                Location loc = zhubo.getLocation();
                // 只设置yaw，不改变位置
                loc.setYaw((float) yaw);
                // 设置新的 yaw，pitch 保持不变
                zhubo.setRotation(loc.getYaw(), loc.getPitch());
                zhubo.getWorld().spawnParticle(Particle.CLOUD, zhubo.getLocation(), 2);
                // 生成云状粒子
                time++;
            }
        }.runTaskTimer(FarmingWar.inst(), 0L, 2L);
        game.addTasks(task);
    }

}
