package com.yaohun.farmingwar.effects;

import com.sk89q.worldedit.EditSession;
import com.sk89q.worldedit.WorldEdit;
import com.sk89q.worldedit.bukkit.BukkitAdapter;
import com.sk89q.worldedit.math.BlockVector3;
import com.sk89q.worldedit.regions.CuboidRegion;
import com.yaohun.farmingwar.FarmingWar;
import com.yaohun.farmingwar.game.Game;
import com.yaohun.farmingwar.game.GameSite;
import com.yaohun.farmingwar.game.Point;
import com.yaohun.farmingwar.game.Region;
import com.yaohun.farmingwar.util.ExpandType;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.boss.BossBar;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.entity.Wither;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;
import org.bukkit.util.Vector;
import tools.CDTimeAPI;
import tools.GameUtil;
import tools.RandomUtil;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.UUID;

public class GameSiteExpand {

    public static void apply(Game game,ExpandType expandType, int amount) {
        if (!game.isStarted()) {
            return;
        }
        // 获取这个类型是否已存在数据
        if(integerHashMap.get(expandType) == null){
            integerHashMap.put(expandType,amount);
        } else {
          int theOldAmount = integerHashMap.get(expandType);
          integerHashMap.put(expandType,(theOldAmount+amount));
        }
        startTimepieceEvent(game);
    }

    public static boolean timerState = false;
    public static HashMap<ExpandType,Integer> integerHashMap = new HashMap<>();

    public static void startTimepieceEvent(Game game) {
        if (timerState) {return;}
        timerState = true;
        BukkitTask task = new BukkitRunnable() {
            private int i = 0;
            @Override
            public void run() {
                if (integerHashMap.isEmpty()) {
                    timerState = false;
                    cancel();
                    return;
                }
                for (ExpandType expandType : integerHashMap.keySet()){
                    if(expandType.equals(ExpandType.KuoJian)){
                        int theOldAmount = integerHashMap.get(expandType);
                        GameUtil.sendAllTitle("§c扩建场地§ex"+theOldAmount,"§r",0,10,10);
                        KuoJianSite(game);
                        if(theOldAmount <= 1){
                            integerHashMap.remove(expandType);
                        } else {
                            integerHashMap.put(expandType,(theOldAmount-1));
                        }
                        GameUtil.sendAllSound("ei");
                    } else if(expandType.equals(ExpandType.ChaiChu)){
                        int theOldAmount = integerHashMap.get(expandType);
                        GameUtil.sendAllTitle("§c扩建拆除§ex"+theOldAmount,"§r",0,10,10);
                        ChaiChuSite(game);
                        if(theOldAmount <= 1){
                            integerHashMap.remove(expandType);
                        } else {
                            integerHashMap.put(expandType,(theOldAmount-1));
                        }
                        GameUtil.sendAllSound("biu");
                    }
                }
                i--;
            }
        }.runTaskTimer(FarmingWar.inst(), 0L, 2L);
        game.addTasks(task);
    }

    public static void KuoJianSite(Game game){
        Region region = game.getRegion();
        int cacheX = (int) Math.floor(region.getMax().getX());
        double x = cacheX + 1;
        Point point = region.getMax();
        point.setX(x);
        region.setMax(point);
        int siteY = 72;
        BlockVector3 p1 = BlockVector3.at((region.getMax().getX()+1), siteY, (region.getMin().getZ()-1));
        BlockVector3 p2 = BlockVector3.at((region.getMax().getX()+1), siteY,  (region.getMax().getZ()+1));
        CuboidRegion oakLogRegion = new CuboidRegion(BukkitAdapter.adapt(region.getWorld()), p1, p2);
        try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(region.getWorld()))) {
            editSession.setBlocks((com.sk89q.worldedit.regions.Region) oakLogRegion, BukkitAdapter.asBlockType(Material.OAK_LOG));
        } catch (Exception e) {
            e.printStackTrace();
        }
        Bukkit.getScheduler().runTaskLater(FarmingWar.inst(), () -> {
            BlockVector3 vector1 = BlockVector3.at((region.getMax().getX()), siteY, (region.getMin().getZ()));
            BlockVector3 vector2 = BlockVector3.at((region.getMax().getX()), siteY,  (region.getMax().getZ()));
            CuboidRegion cuboidRegion = new CuboidRegion(BukkitAdapter.adapt(region.getWorld()), vector1, vector2);
            try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(region.getWorld()))) {
                editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion, BukkitAdapter.asBlockType(Material.FARMLAND));
            } catch (Exception e) {
                e.printStackTrace();
            }
        }, 1L);
    }

    public static void ChaiChuSite(Game game){
        Region region = game.getRegion();
        int cacheX = (int) Math.floor(region.getMax().getX());
        double x = cacheX - 1;
        if(x < -223){
            Bukkit.broadcastMessage("§c[消息]§a已经最小了,不能再继续拆啦！");
            return;
        }
        Point point = region.getMax();
        point.setX(x);
        region.setMax(point);
        int siteY = 72;
        BlockVector3 p1 = BlockVector3.at((region.getMax().getX()+1), siteY, (region.getMin().getZ()-1));
        BlockVector3 p2 = BlockVector3.at((region.getMax().getX()+2), siteY+1,  (region.getMax().getZ()+1));
        CuboidRegion clearRegion = new CuboidRegion(BukkitAdapter.adapt(region.getWorld()), p1, p2);
        try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(region.getWorld()))) {
            editSession.setBlocks((com.sk89q.worldedit.regions.Region) clearRegion, BukkitAdapter.asBlockType(Material.AIR));
        } catch (Exception e) {
            e.printStackTrace();
        }
        Bukkit.getScheduler().runTaskLater(FarmingWar.inst(), () -> {
            BlockVector3 vector1 = BlockVector3.at((region.getMax().getX()+1), siteY, (region.getMin().getZ()-1));
            BlockVector3 vector2 = BlockVector3.at((region.getMax().getX()+1), siteY,  (region.getMax().getZ()+1));
            CuboidRegion cuboidRegion = new CuboidRegion(BukkitAdapter.adapt(region.getWorld()), vector1, vector2);
            try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(region.getWorld()))) {
                editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion, BukkitAdapter.asBlockType(Material.OAK_LOG));
            } catch (Exception e) {
                e.printStackTrace();
            }
        }, 2L);
    }

}
