package com.yaohun.farmingwar.effects;

import com.yaohun.farmingwar.FarmingWar;
import com.yaohun.farmingwar.game.Game;
import org.bukkit.Effect;
import org.bukkit.Location;
import org.bukkit.Particle;
import org.bukkit.Sound;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.entity.TNTPrimed;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;
import tools.CDTimeAPI;

import java.util.UUID;

public class JumpTnt {

    public static void apply(Game game, Player zhubo, int seconds){
        // 检测游戏是否启动
        if(!game.isStarted()){return;}
        // 获取主播的uuid
        UUID uuid = zhubo.getUniqueId();
        // 计时器key
        String timepieceKey = "jumpTnt";
        startTimepieceEvent(game,zhubo,timepieceKey);
        if(CDTimeAPI.isCD(uuid,timepieceKey)){
            long newTime = CDTimeAPI.getCD(uuid,timepieceKey) + (495L * seconds);
            CDTimeAPI.setPlayerCD(uuid,timepieceKey,newTime);
        } else {
            CDTimeAPI.setPlayerCD(uuid,timepieceKey,495L * seconds);
        }
    }

    public static void startTimepieceEvent(Game game,Player zhubo,String timepieceKey){
        if(CDTimeAPI.isCD(zhubo.getUniqueId(),timepieceKey)){
            return;
        }
        BukkitTask task = new BukkitRunnable() {
            @Override
            public void run() {
                if (!CDTimeAPI.isCD(zhubo.getUniqueId(), timepieceKey)) {
                    cancel();
                    return;
                }
                if(zhubo.isFlying()){
                    zhubo.setFlying(false);
                }
                zhubo.playSound(zhubo.getLocation(),"huwuqifei",1,1);
                zhubo.setVelocity(zhubo.getLocation().getDirection().multiply(0.5).setY(1.0));
                zhubo.playEffect(zhubo.getLocation(), Effect.MOBSPAWNER_FLAMES, 10);
                zhubo.playSound(zhubo.getLocation(), Sound.ENTITY_BAT_TAKEOFF, 1.0F, 1.0F);
                BukkitTask task1 = new BukkitRunnable() {
                    private int i= 0;
                    @Override
                    public void run() {
                        if(i >= 6){cancel();}
                        Location location = zhubo.getLocation();
                        TNTPrimed tntPrimed = (TNTPrimed) location.getWorld().spawnEntity(location.clone().add(0,-0.5,0), EntityType.PRIMED_TNT);
                        tntPrimed.setFuseTicks(10);
                        tntPrimed.setYield(0.0F);
                        location.getWorld().playSound(location, Sound.ENTITY_CREEPER_PRIMED, 1.0f, 1.0f);
                        i++;
                    }
                }.runTaskTimer(FarmingWar.inst(), 2L,1L);
                game.addTasks(task1);
            }
        }.runTaskTimer(FarmingWar.inst(), 0L, 10L);
        game.addTasks(task);
    }

}
