package com.yaohun.farmingwar.effects;

import com.yaohun.farmingwar.FarmingWar;
import com.yaohun.farmingwar.game.Game;
import com.yaohun.farmingwar.game.Region;
import org.bukkit.Material;
import org.bukkit.Particle;
import org.bukkit.block.Block;
import org.bukkit.block.data.Ageable;
import org.bukkit.block.data.type.Farmland;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;
import tools.CDTimeAPI;
import tools.GameUtil;

import java.util.UUID;

public class SiteFillALl {

    public static void apply(Game game, Player zhubo, boolean all_pro){
        // 检测游戏是否启动
        if(!game.isStarted()){return;}
        int i = 1;
        Region region = game.getRegion();
        for (int x = (int) Math.floor(region.getMin().getX()); x <= region.getMax().getX(); x++) {
            long delay = 1 + (i * 3L);
            int finalX = x;
            int finalI = i;
            BukkitTask task = new BukkitRunnable() {
                @Override
                public void run() {
                    Region region = game.getRegion();
                    if(finalX > region.getMax().getX()){
                        cancel();
                        return;
                    }
                    for (int z = (int) Math.floor(region.getMin().getZ()); z <= region.getMax().getZ(); z++) {
                        Block block = region.getWorld().getBlockAt(finalX, (int) region.getMax().getY(), z);
                        block.getWorld().spawnParticle(Particle.VILLAGER_HAPPY, block.getLocation().add(0.5, 0.5, 0.5), 6, 0.5, 0.5, 0.5, 0.1);
                        // 获取方块是否是小麦
                        if (block.getType() == Material.WHEAT) {
                            // 如果是小麦则设置为7
                            if(block.getBlockData() instanceof Ageable ageable) {
                                ageable.setAge(7);
                                block.setBlockData(ageable);
                            }
                        } else {
                            // 获取泥土方块
                            Block farmland_block = block.getRelative(0,-1,0);
                            if(farmland_block.getBlockData() instanceof Farmland farmland){
                                if(all_pro){
                                    // 设置为湿润泥土并设置小麦
                                    farmland.setMoisture(7);
                                    farmland_block.setBlockData(farmland);
                                    block.setType(Material.WHEAT);
                                    if (block.getBlockData() instanceof Ageable ageable) {
                                        ageable.setAge(7);
                                        block.setBlockData(ageable);
                                    }
                                }else {
                                    // 判断泥土是否是湿润泥土
                                    if (farmland.getMoisture() == farmland.getMaximumMoisture()) {
                                        block.setType(Material.WHEAT);
                                        if (block.getBlockData() instanceof Ageable ageable) {
                                            ageable.setAge(7);
                                            block.setBlockData(ageable);
                                        }
                                    }else{
                                        farmland.setMoisture(7);
                                        farmland_block.setBlockData(farmland);
                                        block.setType(Material.WHEAT);
                                        if (block.getBlockData() instanceof Ageable ageable) {
                                            ageable.setAge(3);
                                            block.setBlockData(ageable);
                                        }
                                    }
                                }
                            }
                        }
                    }
                    if(finalI % 8 == 0) {
                        GameUtil.sendAllSound("mofaxiufu");
                    }
                }
            }.runTaskLater(FarmingWar.inst(), delay);
            i++;
            game.addTasks(task);
        }
    }

}
