package com.yaohun.farmingwar.effects;

import com.yaohun.farmingwar.FarmingWar;
import com.yaohun.farmingwar.game.Game;
import org.bukkit.*;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.entity.TNTPrimed;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;
import org.bukkit.util.Vector;
import tools.CDTimeAPI;
import tools.GameUtil;
import tools.RandomUtil;

import java.util.UUID;

public class SpawnTnt {

    public static void apply(Game game, Player zhubo, int seconds){
        // 检测游戏是否启动
        if(!game.isStarted()){return;}
        // 获取主播的uuid
        UUID uuid = zhubo.getUniqueId();
        // 计时器key
        String timepieceKey = "spawnTnt";
        startTimepieceEvent(game,zhubo,timepieceKey);
        if(CDTimeAPI.isCD(uuid,timepieceKey)){
            long newTime = CDTimeAPI.getCD(uuid,timepieceKey) + (495L * seconds);
            CDTimeAPI.setPlayerCD(uuid,timepieceKey,newTime);
        } else {
            CDTimeAPI.setPlayerCD(uuid,timepieceKey,495L * seconds);
        }
    }

    public static void startTimepieceEvent(Game game,Player zhubo,String timepieceKey){
        if(CDTimeAPI.isCD(zhubo.getUniqueId(),timepieceKey)){
            return;
        }
        BukkitTask task = new BukkitRunnable() {
            @Override
            public void run() {
                if (!CDTimeAPI.isCD(zhubo.getUniqueId(), timepieceKey)) {
                    cancel();
                    return;
                }
                for (int i = 0; i < 3; i++) {
                    Bukkit.getScheduler().runTaskLater(FarmingWar.inst(), () -> {
                        Location location = zhubo.getLocation().clone();
                        TNTPrimed tntPrimed = (TNTPrimed) zhubo.getWorld().spawnEntity(location, EntityType.PRIMED_TNT);
                        new BukkitRunnable() {
                            private int timer = 0;
                            @Override
                            public void run() {
                                if(timer >= 20 || tntPrimed.isDead()){
                                    cancel();
                                    return;
                                }
                                location.getWorld().spawnParticle(Particle.FIREWORKS_SPARK,tntPrimed.getLocation(),2);
                                timer++;
                            }
                        }.runTaskTimer(FarmingWar.inst(),0,2L);
                        tntPrimed.setFuseTicks(30);
                        tntPrimed.setYield(2.0F);
                        tntPrimed.setVelocity(GameUtil.getRandomVector(0.5,0.2));
                        location.getWorld().playSound(location, Sound.ENTITY_CREEPER_PRIMED, 1.0f, 1.0f);
                    }, (long) i * 2);
                }
            }
        }.runTaskTimer(FarmingWar.inst(), 0L, 10L);
        game.addTasks(task);
    }

}
