package com.yaohun.farmingwar.effects;

import com.yaohun.farmingwar.FarmingWar;
import com.yaohun.farmingwar.game.Game;
import com.yaohun.farmingwar.game.Region;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.boss.BossBar;
import org.bukkit.entity.EnderDragon;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.entity.Wither;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;
import org.bukkit.util.Vector;
import tools.CDTimeAPI;
import tools.RandomUtil;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class SummonTheDragon {

    public static void apply(Game game, Player zhubo, String userName, int amount) {
        if (!game.isStarted()) {
            return;
        }
        // 获取主播的uuid
        UUID uuid = zhubo.getUniqueId();
        // 计时器key
        String timepieceKey = "SummonDragonEffect";
        startTimepieceEvent(game,zhubo,userName,timepieceKey);
        if(CDTimeAPI.isCD(uuid,timepieceKey)){
            long newTime = CDTimeAPI.getCD(uuid,timepieceKey) + (4950L * amount);
            CDTimeAPI.setPlayerCD(uuid,timepieceKey,newTime);
        } else {
            CDTimeAPI.setPlayerCD(uuid,timepieceKey,4950L * amount);
        }
    }

    public static void startTimepieceEvent(Game game,Player zhubo,String userName,String timepieceKey) {
        if (CDTimeAPI.isCD(zhubo.getUniqueId(), timepieceKey)) {
            return;
        }
        BukkitTask task = new BukkitRunnable() {
            @Override
            public void run() {
                if (!CDTimeAPI.isCD(zhubo.getUniqueId(), timepieceKey)) {
                    cancel();
                    return;
                }
                World world = game.getRegion().getWorld();
                spawnMobs(game,userName,new Location(world,-224.5,73,252.0));
                spawnMobs(game,userName,new Location(world,-224.5,73,261.0));
            }
        }.runTaskTimer(FarmingWar.inst(), 0L, 20L * 5);
        game.addTasks(task);
    }

    public static void spawnMobs(Game game,String userName,Location location){
        location.setYaw(-90);
        Region region = game.getRegion();
        EnderDragon entity = (EnderDragon) location.getWorld().spawnEntity(location, EntityType.ENDER_DRAGON);
        entity.setTarget(null);
        entity.setCollidable(false);
        entity.setMaxHealth(300);
        BossBar bossBar = entity.getBossBar();
        if (bossBar != null) {
            bossBar.removeAll();
        }
        entity.setCustomNameVisible(true);
        entity.setCustomName("§c" + userName);
        BukkitTask task = new BukkitRunnable() {
            private int i = 0;
            // 计算将在多少i后自动消失
            private double remove_x_i = (region.getMax().getX() - region.getMin().getX()) * 7;
            private List<Integer> integerList = new ArrayList<>();
            @Override
            public void run() {
                Location location = entity.getLocation().clone();
                if(i >= remove_x_i){
                    if(!entity.isDead()) {
                        entity.setHealth(0);
                    }
                    cancel();
                    return;
                }
                if (entity.isDead() || location.getX() >= region.getMax().getX()+0.5) {
                    if(!entity.isDead()) {
                        entity.setHealth(0);
                    }
                    cancel();
                    return;
                }
                Vector vector0 = new Vector(1, 0, 0);
                vector0.normalize();
                vector0.multiply(0.15);
                Location location1 = entity.getLocation().add(vector0);
                location1.setYaw(90);
                location1.setPitch(0);
                entity.teleport(location1);
                location.setY(region.getMax().getY());
                if(i % 4 == 0 && RandomUtil.getRandomInt(1,100) >= 95){
                    location.getWorld().strikeLightningEffect(location);
                }
                BossBar bossBar = entity.getBossBar();
                if (bossBar != null) {
                    bossBar.removeAll();
                }
                // 破坏方块的范围
                int range = 8;
                int centerZ = location.getBlockZ();
                // 遍历周围的 z 坐标
                for (int z = centerZ - range; z <= centerZ + range; z++) {
                    // 获取当前坐标的方块
                    Block block = region.getWorld().getBlockAt((int) location.getX(), (int) location.getY(), z);
                    // 判断这个方块是否在游戏场地
                    if (region.isInRegion(block.getLocation())) {
                        // 获取这个方块的ID代号
                        int hashCode = block.hashCode();
                        // 判断这个方块是否已录入系统  若已录入则跳过
                        if (!integerList.contains(hashCode)) {
                            integerList.add(hashCode);
                            block.setType(Material.AIR);
                            block.getRelative(0, -1, 0).setType(Material.FARMLAND);
                        }
                    }
                }
                i++;
            }
        }.runTaskTimer(FarmingWar.inst(), 1L, 1L);
        game.addTasks(task);
    }

}
