package com.yaohun.farmingwar.game;

import com.yaohun.farmingwar.FarmingWar;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.data.Ageable;
import org.bukkit.block.data.BlockData;
import org.bukkit.block.data.type.Farmland;
import org.bukkit.scheduler.BukkitRunnable;
import tools.RandomUtil;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;

public class GameSite {

    public static void restoreInitialization(){
        Game game = FarmingWar.getGame();
        Region region = game.getRegion();
        int i = 0;
        for (int y = (int) Math.floor(region.getMin().getY()); y <= region.getMax().getY(); y++) {
            for (int x = (int) Math.floor(region.getMin().getX()); x <= region.getMax().getX(); x++) {
                for (int z = (int) Math.floor(region.getMin().getZ()); z <= region.getMax().getZ(); z++) {
                    Block block = region.getWorld().getBlockAt(x, y, z);
                    if (!block.getType().equals(Material.AIR)) {
                        block.setType(Material.AIR);
                    }
                }
            }
        }
    }

    public static int getCompleteWheatAmount(){
        Game game = FarmingWar.getGame();
        Region region = game.getRegion();
        int i = 0;
        for (int y = (int) Math.floor(region.getMin().getY()); y <= region.getMax().getY(); y++) {
            for (int x = (int) Math.floor(region.getMin().getX()); x <= region.getMax().getX(); x++) {
                for (int z = (int) Math.floor(region.getMin().getZ()); z <= region.getMax().getZ(); z++) {
                    Block block = region.getWorld().getBlockAt(x, y, z);
                    if (!block.getType().equals(Material.AIR)) {
                        BlockData blockData = block.getBlockData();
                        if (blockData instanceof Ageable) {
                            Ageable ageable = (Ageable) blockData;
                            if (ageable.getAge() == 7) {
                                i++;
                            }
                        }
                    }
                }
            }
        }
        return i;
    }

    public static int getCompleteWheatGoal(){
        Game game = FarmingWar.getGame();
        Region region = game.getRegion();
        int x = (int) Math.floor(region.getMax().getX()) - (int) Math.floor(region.getMin().getX()) + 1;
        int y = (int) Math.floor(region.getMax().getY()) - (int) Math.floor(region.getMin().getY()) + 1;
        int z = (int) Math.floor(region.getMax().getZ()) - (int) Math.floor(region.getMin().getZ()) + 1;
        return x * y * z;
    }

    // 获取场地哪一行小麦可以进行收割
    public static List<String> Remove_indexZ_List = new ArrayList<>();
    public static Location getMinerWheat_MaxAmount_Location(){
        Region region = FarmingWar.getGame().getRegion();
        double x = region.getMin().getX() - 0.755;
        double y = region.getMax().getY();
        int indexZ = (int) (region.getMin().getZ() + 0.5);
        // 最终小麦种子数量统计
        LinkedHashMap<Integer,Integer> wheatMap = new LinkedHashMap<>();
        LinkedHashMap<Integer,Integer> seedsMap = new LinkedHashMap<>();
        LinkedHashMap<Integer,Integer> farmlandMap = new LinkedHashMap<>();
        // 从第一行开始遍历至最后一行
        for (int z = indexZ; z <= Math.round(region.getMax().getZ()); z++) {
            if(Remove_indexZ_List.contains(String.valueOf(z))){
                continue;
            }
            // 统计小麦数量
            int wheat_amount = 0;
            int seeds_amount = 0;
            int farmland_amount = 0;
            // 获取纵行x的变化
            for (int x1 = (int) Math.round(region.getMin().getX()); x1 <= Math.round(region.getMax().getX()); x1++) {
                Location location = new Location(region.getWorld(), x1, y, z);
                // 判断方块是否是小麦 若是小麦则检测成熟度
                Block block = location.getBlock();
                if (block.getType() == Material.WHEAT) {
                    if (block.getBlockData() instanceof Ageable ageable) {
                        // 判断小麦成熟度
                        if (ageable.getAge() == 7) {
                            wheat_amount++;
                        }else{
                            seeds_amount++;
                        }
                    }
                }else {
                    Block next_block = block.getRelative(0, -1, 0);
                    if (next_block.getType() == Material.FARMLAND) {
                        if (next_block.getBlockData() instanceof Farmland farmland) {
                            if (farmland.getMoisture() == farmland.getMaximumMoisture()) {
                                farmland_amount++;
                            }
                        }
                    }
                }
            }
            if(wheat_amount >= 1){
                wheatMap.put(z,wheat_amount);
            }else if(seeds_amount >= 1){
                seedsMap.put(z,seeds_amount);
            }else if(farmland_amount >= 1){
                farmlandMap.put(z,farmland_amount);
            }
        }
        if(wheatMap.size() >= 1){
            int a = 0;
            for (Integer z : wheatMap.keySet()){
                if(wheatMap.get(z) >= a){
                    a = wheatMap.get(z);
                    indexZ = z;
                }
            }
        }else if(seedsMap.size() >= 1){
            int a = 0;
            for (Integer z : seedsMap.keySet()){
                if(seedsMap.get(z) >= a){
                    a = seedsMap.get(z);
                    indexZ = z;
                }
            }
        }else if(farmlandMap.size() >= 1){
            int a = 0;
            for (Integer z : farmlandMap.keySet()){
                if(farmlandMap.get(z) >= a){
                    a = farmlandMap.get(z);
                    indexZ = z;
                }
            }
        }else{
            indexZ = -1;
        }
        String indexZ_String = String.valueOf(indexZ);
        Remove_indexZ_List.add(indexZ_String);
        new BukkitRunnable() {
            public void run() {
                Remove_indexZ_List.remove(indexZ_String);
            }
        }.runTaskLater(FarmingWar.inst(), 100L);
        Location location = new Location(region.getWorld(), x+0.5, y, indexZ+0.5);
        if (indexZ == -1) {
            location = RandomUtil.getRandomLocation(region.getWorld(), x, x, y, y, region.getMin().getZ() + 1, region.getMax().getZ() - 1);
        }
        return location;
    }


    public static List<String> Fix_indexZ_List = new ArrayList<>();
    public static Location getMinerWheat_MinAmount_Location(){
        Region region = FarmingWar.getGame().getRegion();
        double x = region.getMin().getX() - 0.755;
        double y = region.getMax().getY();
        int indexZ = (int) (region.getMin().getZ() + 0.5);
        // 最终小麦种子数量统计
        LinkedHashMap<Integer,Integer> seedsMap = new LinkedHashMap<>();
        LinkedHashMap<Integer,Integer> farmlandMap = new LinkedHashMap<>();
        LinkedHashMap<Integer,Integer> dirtMap = new LinkedHashMap<>();
        // 从第一行开始遍历至最后一行
        for (int z = indexZ; z <= Math.round(region.getMax().getZ()); z++) {
            if(Fix_indexZ_List.contains(String.valueOf(z))){
                continue;
            }
            // 统计小麦数量
            int seeds_amount = 0;
            int dirt_amount = 0;
            int farmland_amount = 0;
            // 获取纵行x的变化
            for (int x1 = (int) Math.round(region.getMin().getX()); x1 <= Math.round(region.getMax().getX()); x1++) {
                Location location = new Location(region.getWorld(), x1, y, z);
                // 判断方块是否是小麦 若是小麦则检测成熟度
                Block block = location.getBlock();
                if (block.getType() == Material.WHEAT) {
                    if (block.getBlockData() instanceof Ageable ageable) {
                        // 判断小麦成熟度
                        if (ageable.getAge() != 7) {
                            seeds_amount++;
                        }
                    }
                }else {
                    Block next_block = block.getRelative(0, -1, 0);
                    if (next_block.getType() == Material.FARMLAND) {
                        if (next_block.getBlockData() instanceof Farmland farmland) {
                            if (farmland.getMoisture() != farmland.getMaximumMoisture()) {
                                dirt_amount++;
                            } else {
                                farmland_amount++;
                            }
                        }
                    }
                }
            }
            if(dirt_amount >= 1){
                dirtMap.put(z,dirt_amount);
            }else if(farmland_amount >= 1){
                farmlandMap.put(z,farmland_amount);
            }else if(seeds_amount >= 1){
                seedsMap.put(z,seeds_amount);
            }
        }
        if(dirtMap.size() >= 1) {
            int a = 0;
            for (Integer z : dirtMap.keySet()){
                if(dirtMap.get(z) >= a){
                    a = dirtMap.get(z);
                    indexZ = z;
                }
            }
        }else if(farmlandMap.size() >= 1){
            int a = 0;
            for (Integer z : farmlandMap.keySet()){
                if(farmlandMap.get(z) >= a){
                    a = farmlandMap.get(z);
                    indexZ = z;
                }
            }
        }else if(seedsMap.size() >= 1){
            int a = 0;
            for (Integer z : seedsMap.keySet()){
                if(seedsMap.get(z) >= a){
                    a = seedsMap.get(z);
                    indexZ = z;
                }
            }
        }else{
            indexZ = -1;
        }
        String indexZ_String = String.valueOf(indexZ);
        Fix_indexZ_List.add(indexZ_String);

        new BukkitRunnable() {
            public void run() {
                Fix_indexZ_List.remove(indexZ_String);
                cancel();
            }
        }.runTaskLater(FarmingWar.inst(), 100L);
        Location location = new Location(region.getWorld(), x+0.5, y, indexZ+0.5);
        if (indexZ == -1) {
            location = RandomUtil.getRandomLocation(region.getWorld(), x, x, y, y, region.getMin().getZ() + 1, region.getMax().getZ() - 1);
        }
        return location;
    }

}
