package com.yaohun.farmingwar.game;

import com.yaohun.farmingwar.FarmingWar;
import com.yaohun.farmingwar.util.BackPointType;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.configuration.ConfigurationSection;

public class Region {

    private World world;
    private Point min;
    private Point max;

    public Region(World world, Point min, Point max) {
        this.world = world;
        this.min = min;
        this.max = max;
    }

    public Location getHub(){
        double z = (min.getZ() + max.getZ()) / 2;
        double y = min.getY();
        if(max.getY() > y){
            y = max.getY();
        }
        BackPointType backPointType = FarmingWar.getGameManager().getBackPointType();
        if(backPointType == BackPointType.初始){
            double x = (min.getX() + 1);
            return new Location(world,x,(y+5),z,-90,45);
        }else if(backPointType == BackPointType.尽头){
            double x = (max.getX() - 1);
            return new Location(world,x,(y+5),z,90,45);
        }
        double x = (min.getX() + max.getX()) / 2;
        return new Location(world,x,(y+5),z,-90,90);
    }

    public World getWorld() {
        return world;
    }

    public Point getMin() {
        return min;
    }

    public Point getMax() {
        return max;
    }

    public void setMax(Point max) {
        this.max = max;
    }

    public void setMin(Point min) {
        this.min = min;
    }

    public static Region deserialize(ConfigurationSection section) {
        World world1 = Bukkit.getWorld(section.getString("world"));
        Point point1 = Point.deserialize(section.getConfigurationSection("min"));
        Point point2 = Point.deserialize(section.getConfigurationSection("max"));
        return new Region(world1, point1, point2);
    }

    public boolean isInRegion(Location location) {
        if (!location.getWorld().getName().equalsIgnoreCase(world.getName())) {
            return false;
        }
        return (location.getBlockX() >= this.min.getX()
                && location.getBlockX() <= this.max.getX()
                && location.getBlockY() >= this.min.getY()
                && location.getBlockY() <= this.max.getY()
                && location.getBlockZ() >= this.min.getZ()
                && location.getBlockZ() <= this.max.getZ());
    }

    public boolean isInRegionPlayer(Location location) {
        if (!location.getWorld().getName().equalsIgnoreCase(world.getName())) {
            return false;
        }
        return (location.getBlockX() >= this.min.getX()-1
                && location.getBlockX() <= this.max.getX()+1
                && location.getBlockZ() >= this.min.getZ()-1
                && location.getBlockZ() <= this.max.getZ()+1);
    }

}
