package com.yaohun.farmingwar.listener;

import com.jgxs.yaohun.teleportspigot.api.WarpAPI;
import com.yaohun.farmingwar.FarmingWar;
import com.yaohun.farmingwar.game.Game;
import org.bukkit.Location;
import org.bukkit.Sound;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.entity.Entity;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.scheduler.BukkitRunnable;
import tools.RandomUtil;

public class KeepEntitiesOnDeath implements Listener {

    @EventHandler
    public void onAutoRespawn(EntityDamageByEntityEvent e){
        Entity entity = e.getEntity();
        // 获取当前游戏记录点高度
        Game game = FarmingWar.getGame();
        if(game.isStarted()) {
            if (entity instanceof LivingEntity living) {
                if(living instanceof Player player) {
                    double health = living.getHealth();
                    double beHurt = health - e.getDamage();
                    if (beHurt <= 0) {
                        e.setCancelled(true);
                        player.teleport(game.getRegion().getHub());
                        player.setHealth(player.getMaxHealth());
                        player.playSound(player.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP,1,1);
                        if (RandomUtil.getRandomInt(1,100) >= 50) {
                            player.sendTitle("§4你嘎了", "行不行啊？菜就多练！");
                        } else {
                            player.sendTitle("§4你嘎了", "汗流浃背了？");
                        }
                    }
                }
            }
        }
    }
    @EventHandler
    public void onAutoRespawn(PlayerDeathEvent e) {
        e.setDeathMessage(null);
        Player p = e.getEntity();
        // 获取当前游戏记录点高度
        Game game = FarmingWar.getGame();
        if (game.isStarted()) {
            new BukkitRunnable() {
                private int i = 0;

                public void run() {
                    if (i == 1) {
                        p.spigot().respawn();
                    }
                    if(i == 3) {
                        if (RandomUtil.getRandomInt(1,100) >= 50) {
                            p.sendTitle("§4你嘎了", "行不行啊？菜就多练！");
                        } else {
                            p.sendTitle("§4你嘎了", "汗流浃背了？");
                        }
                        p.setHealth(p.getMaxHealth());
                        game.initPlayerBackpack(p);
                    }
                    if(i == 4) {
                        p.teleport(game.getRegion().getHub());
                        cancel();
                    }
                    i++;
                }
            }.runTaskTimer(FarmingWar.inst(),0L, 2L);
        }
    }
}
